<?php


namespace FiloBlu\GiftWrapExt\Plugin\Magento\GiftMessage\Api;

use Magento\Quote\Api\CartRepositoryInterface as QuoteRepositoryInterface;
use Magento\Framework\Message\ManagerInterface;

class CartRepositoryInterface
{
    /**
     * @var QuoteRepositoryInterface
     */
    private $quoteRepository;

    /**
     * @var ManagerInterface
     */
    private $messageManager;

    public function __construct(
        QuoteRepositoryInterface $quoteRepository,
        ManagerInterface $messageManager
    )
    {
        $this->quoteRepository = $quoteRepository;
        $this->messageManager = $messageManager;
    }

    /**
     * @param \Magento\GiftMessage\Api\CartRepositoryInterface $subject
     * @param $cartId
     * @return bool
     * @throws \Magento\Framework\Exception\NoSuchEntityException
     */
    public function beforeSave(
        \Magento\GiftMessage\Api\CartRepositoryInterface $subject,
        $cartId
    ) {
        $quote = $this->quoteRepository->getActive($cartId);

        $quoteItems = $quote->getItems();
        foreach ($quoteItems as $item)
        {
            if(!is_null($item->getGwId()))
            {
                $this->messageManager->addWarningMessage('Gift wrap for items already set; you can use only one type!');
                return false;
            }
        }
    }
}