<?php


namespace FiloBlu\GiftWrapExt\Plugin\Magento\GiftMessage\Api;

use Magento\Quote\Api\CartRepositoryInterface as QuoteRepositoryInterface;
use Magento\Framework\Message\ManagerInterface;

class ItemRepositoryInterface
{
    /**
     * @var QuoteRepositoryInterface
     */
    private $quoteRepository;

    /**
     * @var ManagerInterface
     */
    private $messageManager;

    public function __construct(
        QuoteRepositoryInterface $quoteRepository,
        ManagerInterface $messageManager
    )
    {
        $this->quoteRepository = $quoteRepository;
        $this->messageManager = $messageManager;
    }

    /**
     * @param \Magento\GiftMessage\Api\ItemRepositoryInterface $subject
     * @param int $cartId
     * @return bool
     * @throws \Magento\Framework\Exception\NoSuchEntityException
     */
    public function beforeSave(
        \Magento\GiftMessage\Api\ItemRepositoryInterface $subject,
        $cartId
    ) {
        $quote = $this->quoteRepository->getActive($cartId);

        if(!is_null($quote->getGwId()))
        {
            $this->messageManager->addWarningMessage('Gift wrap for order already set; you can use only one type!');
            return false;
        }
    }
}